<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plaiframe Docs Class: Session</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plaiframe Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="modules.list.html" class="dropdown-toggle" data-toggle="dropdown">Modules<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-session.html">session</a></li><li><a href="module-variables.html">variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors-DesignError.html">errors~DesignError</a></li><li><a href="module-game-Game.html">game~Game</a></li><li><a href="module-medley-Log.html">medley~Log</a></li><li><a href="module-medley-Queue.html">medley~Queue</a></li><li><a href="module-mongo-Database.html">mongo~Database</a></li><li><a href="module-mongo-Collection.html">mongo~Collection</a></li><li><a href="module-mongo-Document.html">mongo~Document</a></li><li><a href="module-ne-Database.html">ne~Database</a></li><li><a href="module-ne-Collection.html">ne~Collection</a></li><li><a href="module-ne-Document.html">ne~Document</a></li><li><a href="module-session-Session.html">session~Session</a></li><li><a href="module-variables-Variables.html">variables~Variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="externals.list.html" class="dropdown-toggle" data-toggle="dropdown">Externals<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="external-Object.html">Object</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-8">
	
		<div id="main">
			

	<h1 class="page-title">Class: Session</h1>
<section>

<header>
    
        <h2>
            <span class="ancestors"><a href="module-session.html">session</a>~</span>
        
        Session
        </h2>
        
            <div class="class-description"><p>Create or resume session based on level<br>
for resumed sessions restore listeners<br>
for new sessions dispatch START cue</p></div>
        
    
</header>


<article>
    <div class="container-overview">
    
        
<hr>
<dt>
    <h4 class="name" id="Session"><span class="type-signature"></span>new Session(data, db, plugins, client)</h4>
    
    
</dt>
<dd>

    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>data</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>database content of stored sessions in moment of game resume or build</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>db</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>Mongo Databse connection object</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>plugins</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>List of plugins that are activated for the game</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>client</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>socket io namespace</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-41">line 41</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

    
    </div>

    

    

    

    

    

    
        <h3 class="subsection-title">Members</h3>

        <dl>
            
<hr>
<dt class="name" id="references">
    <h4 id="references"><span class="type-signature"></span>references<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>local store of reference names to make finding references easier</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-50">line 50</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="reference_collections">
    <h4 id="reference_collections"><span class="type-signature"></span>reference_collections<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>collections whose documents can be referenced</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-53">line 53</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="cue_stack">
    <h4 id="cue_stack"><span class="type-signature"></span>cue_stack<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>holds cues while they dispatched and installing their listener<br>
only first item is being dispatched and then removes iteself</p>
<p>items can be string or query addressing one cue</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-66">line 66</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="queue">
    <h4 id="queue"><span class="type-signature"></span>queue<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>list of listener objects that are pending.<br>
Corelates with listener DB Collection but also contains plugin specific js objects</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-71">line 71</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="event">
    <h4 id="event"><span class="type-signature"></span>event<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>eventemitter instance is forwarded to plugins on cue to interact with this session</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-74">line 74</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        </dl>
    

    
        <h3 class="subsection-title">Methods</h3>

        <dl>
            
<hr>
<dt>
    <h4 class="name" id="getAllReferences"><span class="type-signature"></span>getAllReferences()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>search for all references in all custom collections and arrange them in one object.</p>
<p>references are arranged like this:</p>
<p>{&lt;reference1_name&gt;:[<document1>,<document2>,...], &lt;reference2_name&gt;:[<document1>,...]}</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-236">line 236</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <ul>
<li>resolves with document containing all referenced documents</li>
</ul>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Promise</span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="loadReferences"><span class="type-signature"></span>loadReferences(collection)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>find referenced documents in colleciton and collect reference names.</p>
<p>append found references to list of reference names/collections <code>this.references</code></p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>collection</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>name of existing data collection</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-274">line 274</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <p>resolves once all references are collected</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Promise</span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="removeReference"><span class="type-signature"></span>removeReference(reference [, collection])</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>Remove reference to document(s)</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Argument</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>reference</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>name of reference (E.g. PlayerA)</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>collection</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            

            <td class="description last"><p>name of collection the reference is in. Remove in all collections if none</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-312">line 312</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <ul>
<li>resolves with count of documents where the reference was removed</li>
</ul>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Promise</span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="removeReferenceByQuery"><span class="type-signature"></span>removeReferenceByQuery(collection, query)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>Remove reference to document(s) using mongo style query.</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>collection</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>name of collection where reference should be removed</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>query</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>
|

<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>mongo style find query leading to documents in collection.</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-345">line 345</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <ul>
<li>resolves with count of documents where the reference was removed</li>
</ul>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Promise</span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="cue"><span class="type-signature"></span>cue(query [, chapter])</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>collect information about cue based on its name<br>
iterate plugin modules to find matching cue keys in their schemes. On match forward cue properties to plugin.<br>
if cue content for plugin is array, forward elements successively so the session does not miss out on listeners nested in an array<br>
if plugin schema defines cue key as listener, store its properties in the listener collection.<br>
to identify listeners originating from this session, the session id is stored with the listener.<br>
if plugin resolves with a value of type string, cue dispatches an immideate followup cue with name of that string.<br>
If there is more than one followup, first cue property that resolves with string dispatches cue.<br>
Cues with immediate followups still install listeners, so they are properly canceled by next cue.</p>
<p>before cue actions are run, listeners of previous cues are canceled following these rules:</p>
<ul>
<li>cancel all listeners whose _path property array is contained in this cues path property array</li>
<li>cancel all listeners whose _path property array contains this cues path property array<br>
uses $all and https://docs.mongodb.com/manual/reference/operator/aggregation/setIsSubset/</li>
</ul>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Argument</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>query</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>
|

<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>query to specify cue in cue array (e.g. {name:'cuename'})<br>
if query is string, cue is identified by name:query.<br>
if it contains '.' its regarded as <chapter>.<cue></p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>chapter</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    'chapter'
                
                </td>
            

            <td class="description last"><p>chapter the cue is in</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-401">line 401</a>
			</li>
		</ul>
	</dd>
	

	

	

	
	<dt class="tag-todo method-doc-label method-doc-details-label">To Do:</dt>
	<dd class="tag-todo">
		<ul>
			<li>cancel listeners if they were not installed.</li>
			</ul>
	</dd>
	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="step"><span class="type-signature"></span>step()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>is called once a cue finished doing his stuff<br>
foremost cue in stack is removed.<br>
If there is another cue in the stack already its being called</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-539">line 539</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="next"><span class="type-signature"></span>next()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>trigger cue. Is used after forwarded as callback to plugin listener</p>
<p>run cue immediate if there is no other cue in the stack.<br>
Anyways enqueue it in stack.</p>
<p>The stack is required in case a listener is fireing before the cue itself is done processing all actions.</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-560">line 560</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="forwardCue"><span class="type-signature"></span>forwardCue(content, plugin, cuename, cuepath, chapter, date)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>forward cue elements to plugin responsible for cue segment<br>
also forward objects that enable the plugin to identify and address this session</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>content</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>cue element that is being forwarded</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>plugin</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>name of plugin module the cue properties shall be forwarded to</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>cuename</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>name of origin cue</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>cuepath</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>



            
            </td>

            

            

            <td class="description last"><p>path the origin cue is in</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>chapter</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>chapter origin cue is in</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>date</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>if cue is recalled due to server restart, this is the original date when it was dispatched</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-586">line 586</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <ul>
<li>may be a cue name string, a cancel function or undefined</li>
</ul>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">string</span>
|

<span class="param-type">function</span>
|

<span class="param-type">undefined</span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="installListener"><span class="type-signature"></span>installListener(type, data, cancel_function, cue_name, path, plugin)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>store cue sections of type listener.<br>
listeners that were stored are retriggered on session restart</p>
<p>all listeners are stored as single items in the games listener Collection</p>
<p>a timestamp is added. ObjectID also contains time data, but it seems it only is as accurate as 1s</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>type</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>type identifier of listener</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>data</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>cue section that was flagged as listener</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>cancel_function</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>whatever the plugin module returned after installing the listener</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>cue_name</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>name of cue the listener was installed in</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>path</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>



            
            </td>

            

            

            <td class="description last"><p>path list of origin cue</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>plugin</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>name of plugin the listener originates from</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-623">line 623</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="enqueue"><span class="type-signature"></span>enqueue()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>stack local instance of an installed listener including its object reference returned by plugin</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-649">line 649</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="splitPath"><span class="type-signature"></span>splitPath(init_cue [, name])</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>create a new path that runs parallel to the existing paths</p>
<p>dispatch first cue for path. Cues path lists are established in webclient.</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Argument</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>init_cue</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>cue that is triggered initially with path creation</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>name</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            

            <td class="description last"><p>to identify path in flow</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-662">line 662</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="joinPath"><span class="type-signature"></span>joinPath(path)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>cancel all listeners for path</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>path</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>



            
            </td>

            

            

            <td class="description last"><p>path list representing path to be joined</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	
	<dt class="important tag-deprecated method-doc-label method-doc-details-label">Deprecated:</dt>
	
    <dd class="yes-def tag-deprecated">
        <ul class="dummy">
            <li>Yes</li>
        </ul>
    </dd>
    
    

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-673">line 673</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="cancelForNeDB"><span class="type-signature"></span>cancelForNeDB(path)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>cancel listener based on cue path when using NeDB. Finds all of sessions listener and uses Array.every to compare arrays.</p>
<p>nedb does neither suppert $all nor $expr operator<br>
https://github.com/louischatriot/nedb/issues/278<br>
this would cover 1 half of cancel query ($all):<br>
let query = { $or:[{$and:[]}] }<br>
for(let path of cue.path) {<br>
query[&quot;$or&quot;][0][&quot;$and&quot;].push({_path:path})<br>
}<br>
But so far I didn't come up with a query for the second half ($expr/$setIsSubset)</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>path</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>



            
            </td>

            

            

            <td class="description last"><p>current cue path list</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-691">line 691</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <ul>
<li>latest call is cancel() which returns array of removed listeners.</li>
</ul>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Promise</span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="cancel"><span class="type-signature"></span>cancel()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>removes all listeners that are matching the query and are assigned to the session.<br>
listeners are removed from listener collection<br>
once cancel function was called on and from local session queue after cancel function is called on queue item.</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-724">line 724</a>
			</li>
		</ul>
	</dd>
	

	

	

	
	<dt class="tag-todo method-doc-label method-doc-details-label">To Do:</dt>
	<dd class="tag-todo">
		<ul>
			<li>maybe (once needed) wait for plugins cancel functions to return promise before resolving this function</li>
			</ul>
	</dd>
	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <p>array of deleted listener objects. Empty array if query didn't return listener. Resolves once all cancel functions returned.</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Promise</span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="quit"><span class="type-signature"></span>quit()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>cancel all listeners and remove all references to this session (player etc.)</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-780">line 780</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <p>name and level</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Promise</span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="clientConnection"><span class="type-signature"></span>clientConnection(socket)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>communication with session control webview</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>socket</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>



            
            </td>

            

            

            <td class="description last"><p>io socket connection accessing session</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-804">line 804</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="command"><span class="type-signature"></span>command()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>react on std input addressing this session</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="session.js.html">session.js</a>,
				 <a href="session.js.html#sunlight-1-line-856">line 856</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        </dl>
    

    

    
</article>

</section>




		</div>
	</div>

	<div class="clearfix"></div>

	
		<div class="col-md-3">
			<div id="toc" class="col-md-3 hidden-xs hidden-sm hidden-md"></div>
		</div>
	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/webview/'>Webview Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>